<?php
/**
* Plugin WDDtouit
*
* @package	PLX
* @version	1.0
* @date	16/09/16
* @author Bronco
**/
class WDDtouit extends plxPlugin {

	private $cats; #string
	private $title; #string
	private $catId; #string

	public function __construct($default_lang) {
		
		# appel du constructeur de la classe plxPlugin (obligatoire)
		parent::__construct($default_lang);		
		
		# limite l'acces a l'ecran de configuration du plugin
		# PROFIL_ADMIN , PROFIL_MANAGER , PROFIL_MODERATOR , PROFIL_EDITOR , PROFIL_WRITER
		$this->setConfigProfil(PROFIL_ADMIN);
		
		
		# Declaration d'un hook (existant ou nouveau)
		$this->addHook('IndexBegin','IndexBegin');
		$this->addHook('AdminIndexPrepend','AdminIndexPrepend');
		$this->addHook('AdminPrepend','AdminPrepend');
		$this->addHook('AdminArticlePrepend','AdminArticlePrepend');
		$this->addHook('AdminArticleFoot','AdminArticleFoot');
		
		$this->addHook('plxAdminEditArticle','plxAdminEditArticle');
		$this->addHook('plxAdminEditArticleXml','plxAdminEditArticleXml');
		$this->addHook('AdminArticleContent','AdminArticleContent');
		$this->addHook('AdminProfilTop','AdminProfilTop');		
		$this->addHook('showBookmarkletTouit','showBookmarkletTouit');
		$this->addHook('getTagList','getTagList');		
		$this->addHook('showtouitRSSLink','showtouitRSSLink');
		$this->addHook('plxFeedRssArticlesXml','plxFeedRssArticlesXml');
		$this->title=$this->getParam("titre");

		
		
	}

	# Activation / desactivation
	public function OnActivate() {
		if (empty($this->title)){
			$this->title="Touit";
			$this-> setParam("titre", "Touit", "string");
		}
		if (empty($this->catId)){
			$this->setCatId();
		}
			
		$newcat='<categorie number="'.$this->catId.'" active="1" tri="desc" bypage="5" menu="non" url="'.plxUtils::title2url($this->title).'" template="categorie.php"><name><![CDATA['.$this->title.']]></name><description><![CDATA[Messages courts mais pas trop quand même.]]></description><meta_description><![CDATA[Trouvé sur le net]]></meta_description><meta_keywords><![CDATA[Messages courts mais pas trop quand même.]]></meta_keywords><title_htmltag><![CDATA['.$this->title.']]></title_htmltag></categorie>';
		$categories=file_get_contents('../../'.PLX_CONFIG_PATH.'categories.xml');
		$categories=str_replace('</document>',$newcat.'</document>',$categories);
		file_put_contents('../../'.PLX_CONFIG_PATH.'categories.xml', $categories);
	
	}
	public function OnDeactivate() {
		# code à executer à la désactivation du plugin
	}
	

	########################################
	# HOOKS
	########################################





	########################################
	# IndexBegin
	########################################
	# Description:
	public function IndexBegin(){
		global $plxMotor,$plxPlugins,$plxShow,$plxToken;
		$this->setCatId();
		if (empty($_SESSION['user'])){ # pas connecté
			$pw_input    ='<label>Mot de passe</label><input type="password" name="password"/>';
			$action      =PLX_CORE.'admin/auth.php';
			
		}else{ # connecté
			$pw_input    ='';
			$action      =PLX_CORE.'admin/article.php';
			
		}

		#gestion de la génération du formulaire si on vient du bookmarklet
		if (!empty($_GET['source'])&&$_GET['source']=='bookmarklettouit'){
			$artId                         = $this->newIdArticle();
			$token                         = sha1(mt_rand(0, 1000000));
			$_SESSION['formtoken'][$token] = time();
			$token                         ='<input name="token" value="'.$token.'" type="hidden" />';				
			$login                         = $plxMotor->aUsers[strip_tags($_GET['user'])]['login'];
			$media_link					   ="
			var title = 'medias';window.open('".PLX_CORE."admin/medias.php','','menubar=no,height=' + screen.height +',width=' + screen.width+',toolbar=no,scrollbars=auto,status=no,top=0,left=0');
			";
			

			echo '<html><head><title>Touiter sur le site</title><meta http-equiv="Content-Type" content="text/html; charset=utf-8" />';
			echo '
			
			<link rel="stylesheet" href="./'.$plxShow->plxMotor->aConf['racine_themes'].$plxShow->plxMotor->style.'/css/theme.css"/>
			<link rel="stylesheet" href="./'.$plxShow->plxMotor->aConf['racine_themes'].$plxShow->plxMotor->style.'/css/admin.css"/>
			<link rel="stylesheet" href="./'.$plxShow->plxMotor->aConf['racine_themes'].$plxShow->plxMotor->style.'/css/plucss.css"/>
			<link rel="stylesheet" href="'.PLX_PLUGINS.'WDDtouit/style.css"/>

			</head><body><div class="container touit">';
			echo '
				<h1> Touiter sur le site </h1>
				<form action="'.$action.'" method="post" enctype="multipart/form-data" >
					'.$token.'
					<input type="hidden" name="source" value="bookmarklettouit"/>
					<input type="hidden" name="login" value="'. $login.'"/>
					<input type="hidden" name="author" value="'.$_GET['user'].'"/>

					<input type="hidden" name="date_publication_day" value="'.date('d').'"/>
					<input type="hidden" name="date_publication_day" value="'.date('d').'"/>
					<input type="hidden" name="date_creation_day" value="'.date('d').'"/>
					<input type="hidden" name="date_update_day" value="'.date('d').'"/>

					<input type="hidden" name="date_publication_month" value="'.date('m').'"/>
					<input type="hidden" name="date_creation_month" value="'.date('m').'"/>
					<input type="hidden" name="date_update_month" value="'.date('m').'"/>

					<input type="hidden" name="date_publication_year" value="'.date('Y').'"/>
					<input type="hidden" name="date_creation_year" value="'.date('Y').'"/>
					<input type="hidden" name="date_update_year" value="'.date('Y').'"/>

					<input type="hidden" name="date_publication_time" value="'.date('H:i').'"/>
					<input type="hidden" name="date_creation_time" value="'.date('H:i').'"/>
					<input type="hidden" name="date_update_time" value="'.date('H:i').'"/>

					<input type="hidden" name="new_catname" value=""/>
					<input type="hidden" name="title_htmltag" value=""/>
					<input type="hidden" name="meta_description" value=""/>
					<input type="hidden" name="meta_keywords" value=""/>
					<input type="hidden" name="artId" value="'.$artId.'"/>
					<input type="hidden" name="catId[]" value="'.$this->catId.'"/>
					<input type="hidden" name="thumbnail_title" value=""/>
					<input type="hidden" name="thumbnail_alt" value="image titre"/>
					<input type="hidden" name="url" value=""/>
					<input type="hidden" name="url_link" value=""/>
					<input type="hidden" name="chapo" value=""/>
					<input type="hidden" name="template" value="article.php"/>';
					
					echo $pw_input;

					echo '
					<label>Titre</label>
					<input type="text" name="title" value="Touit du '.$this->today().'"  placeholder="Titre du touit"/>
					<label>Image</label>
					<input type="file" name="thumbnail" value="" placeholder="image d\'illustration: http://www.domain.fr/image.png"  accept="image/*"/>
					<input type="url" name="image" value="" list="tags_list" placeholder="http://image.com/a/recuperer"/>				
					<label>Contenu du post</label>';
					eval($plxShow->callHook("markdownBar","#id_content"));
					echo'
					 	<textarea id="id_content" name="content" placeholder="Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum."></textarea>
					 	<small>pour insérer des vidéos/des liens/des images, il suffit de coller leur adresse</small>
					<label>Tags</label>
						<input type="text" name="tags" value="" list="tags_list" placeholder="tag1,tag2..."/>
					 	<datalist id="tags_list">'.$this->getTagList().'</datalist>
					 
					<label><input type="checkbox" name="allow_com" value="1" checked/> Commentaires</label>

					 <div class="save-fixed">
					 	<input type="button" onclick="'.$media_link.';return false;" value="&#9712; Medias"/>
					 	<input type="submit" name="publish" value="☀ Publier (public)"/>
					 	<input type="submit" name="draft"   value="✋ Brouillon (privé)"/>
					 </div><div class="emotes_list">';
					global $plxShow; 
					
					eval($plxShow->callHook("WDD_replace_list","active_emotes"));
					eval($plxShow->callHook("WDD_replace_js"));
					eval($plxShow->callHook("markdownJs"));
					eval($plxShow->callHook("markdownAssets"));
				echo '</div></form>
				</div></body></html>
			';
			exit();
		}
		
	}

	########################################
	# AdminPrepend
	########################################
	# Description:
	public function AdminPrepend(){
		
		echo '<?php
		
		if (!empty($_POST["source"])&&empty($_SESSION["post"])){ 			
			$_SESSION["post"]=$_POST;
			if (!empty($_FILES["thumbnail"])){
				$_SESSION["files"]=$_FILES;
			}			
		}
		
		?>';
	}
	########################################
	# AdminIndexPrepend
	########################################
	# Description:
	public function AdminIndexPrepend(){
		# redirige vers article.php après une connexion via le bookmarklet
		echo '<?php 
		if (!empty($_SESSION["post"])||!empty($_POST["source"])){ 			
			header("location: '.PLX_CORE.'admin/article.php");
		}
		
		?>';
	}

	########################################
	# AdminArticlePrepend
	########################################
	public function AdminArticlePrepend(){

		if (empty($_POST['source']) && !empty($_SESSION['post'])){
			$_POST=$_SESSION['post'];
		}
		if (empty($_FILES['thumbnail']) && !empty($_SESSION['files'])){
			$_FILES['thumbnail']=$_SESSION['files'];
		}

		# on vient de poster via le bookmarklet ?
		if (!empty($_POST['source'])&&$_POST['source']=='bookmarklettouit'){	
			# Si on a posté une image d'illustration, on gère l'upload
			if (!empty($_FILES['thumbnail']["name"])&&empty($_FILES['error'])){
				$dest_path=PLX_ROOT.'data/medias/images/_TOUITS';
				if (!is_dir($dest_path)){mkdir($dest_path);}
				$tmp=$_FILES['thumbnail']['tmp_name'];
				$fil=explode('?',strip_tags(basename($_FILES['thumbnail']['name'])));
				$fil=$fil[0];
				$fil=plxUtils::title2url(strip_tags($_POST['title'])).'-'.$fil;
				$loc=$dest_path.'/'.$fil;

				if (stripos($_FILES['thumbnail']['type'],'image/')!==false){
					rename ($tmp,$loc);	
					chmod($loc,0644);
					$_FILES['thumbnail']['name']=$loc;
				}else{$_FILES['thumbnail']['name']="";}
			}
			
			$_POST['content']=nl2br($_POST['content']);
			
			# gestion des données du formulaire
			if (!empty($_FILES['thumbnail']["name"])){
				echo '<?php $_POST["thumbnail"]="'.$_FILES['thumbnail']["name"].'";?>';
			}elseif (!empty(trim($_POST['image']))){
				# si on a fourni l'url d'une image, on la récupère en local
				$_POST['image']=strip_tags($_POST['image']);
				$dest_path=PLX_ROOT.'data/medias/images/_TOUITS';
				$fil=explode('?',basename($_POST['image']));
				$fil=$fil[0];
				$fil=plxUtils::title2url(strip_tags($_POST['title'])).'-'.$fil;
				$loc=$dest_path.'/'.$fil;
				$image=file_get_contents($_POST['image']);
				$_POST['content'].='<div class="img_source"><a href="'.$_POST['image'].'">Source image</a></div>';
				if ($image){
					file_put_contents($loc,$image);
					chmod($loc,0644);
					echo '<?php $_POST["thumbnail"]="data/medias/images/_TOUITS/'.$fil.'"; ?>';
				}else{
					echo '<?php $_POST["thumbnail"]=""; ?>';
				}
			}
				
			unset($_SESSION["post"]);
			$_SESSION['close_bookmarklet']=true;
			unset($_FILES);
		}
		
	}

	##############################################################################
	# AdminArticleFoot
	##############################################################################
	# ferme le bookmarklet
	public function AdminArticleFoot(){
		if (!empty($_SESSION['close_bookmarklet'])){
			unset($_SESSION['close_bookmarklet']);
			echo '<script>window.close();</script>';
		}
	}

	##############################################################################
	# plxAdminEditArticleXml
	##############################################################################
	# Ajoute le stockage de l'adresse du lien dans le fichier de l'article
	public function plxAdminEditArticleXml(){
		echo '<?php 					
					$xml = str_replace("../../","",$xml); # corriger le problème de chemin relatif (sale mais j\'ai pas trouvé mieux :-/)
				?>';
	}

	##############################################################################
	# plxAdminEditArticle
	##############################################################################
	# Récupère le fichier image s'il y en a
	public function plxAdminEditArticle(){
		echo '<?php
				if (empty($content["date_update_old"])){
					$content["date_update_old"]=$content["date_creation_year"].$content["date_creation_month"].$content["date_creation_day"].substr(str_replace(":","",$content["date_creation_time"]),0,4);
				}
				?>';
		
	}


	########################################
	# AdminProfilTop
	########################################
	# Description:
	public function AdminProfilTop(){
		$this->showBookmarkletTouit();
	}


	########################################
	# showtouitRSSLink
	########################################
	# Affichage du lien vers le flux rss de la catégorie touit
	public function showtouitRSSLink(){
		global $plxShow;
		$catId=$this->setCatId();
		echo '<a class="RSS_feed" href="';
		$plxShow->urlRewrite(PLX_ROOT.'feed.php?rss/categorie'.$catId);
		echo '" title="Flux RSS de '.$this->title.'">'.$this->title.'</a>';
	}

	########################################
	# showBookmarkletTouit
	########################################
	# Description:
	public function showBookmarkletTouit($js=true){
		global $plxMotor,$plxAdmin;
		if (empty($plxMotor->racine)){
			$root=$plxAdmin->racine;
		}else{
			$root=$plxMotor->racine;
		}
		if ($js){
			echo '<style>
					#profil .WDDtouitBookmarklet{
					    padding:15px;
					    background:rgba(0,0,0,0.2);
					    list-style:none;
					    margin:5px;
					    display:inline-block;
					}
					#profil .WDDtouitBookmarklet *{
					    vertical-align:middle;
					}
					#profil .WDDtouitBookmarklet img{
					    width:32px;height:auto;
					}
				</style>';
			echo '<li class="WDDtouitBookmarklet"><a href="javascript:javascript:(function(){var url = location.href;var title = document.title || url;window.open(\''.$root.'?url=\' + encodeURIComponent(url)+\'&user='.$_SESSION['user'].'\'+\'&title=\' + encodeURIComponent(title)+\'&source=bookmarklettouit\',\'mybookmarklet\',\'\');})();" title="'.$this->getLang('L_DRAG_THIS_LINK').'"><img src="'.PLX_PLUGINS.'WDDtouit/icon.png"> '.$this->getLang('L_POST_A_LINK').'</a></li>';
		}else{
			echo '<li class="WDDtouitBookmarklet"><a href="'.$root.'?url= &user='.$_SESSION['user'].'&title= &source=bookmarklettouit" title="'.$this->getLang('L_DRAG_THIS_LINK').'"><img src="'.PLX_PLUGINS.'WDDtouit/icon.png"> '.$this->getLang('L_POST_A_LINK').'</a></li>';
		}
	}

	########################################
	# Private methods
	########################################
	private function getTagList($tags_array=false){
		global $plxMotor;$tags=array();
		foreach($plxMotor->aTags as $article){
			$tag=array_flip(array_map('trim',explode(',',$article['tags'])));
			$tags=array_merge($tags,$tag);
		}
		if (!$tags_array){
			$taglist='';
			foreach($tags as $tag=>$osef){if (!empty($tag)){$taglist.='<option value="'.$tag.'">'.$tag.'</option>';}}
	 		return $taglist;
	 	}
	 	return $tags;
	}

	private function newIdArticle(){
		global $plxMotor;
		$arts=$plxMotor->activeArts;		
		$max=0;
		foreach ($arts as $id => $data) {
			$max=max($max,intval($id));
		}
		$max++;
		$max="$max";
		$max=str_repeat('0', 4-strlen($max)).$max;
		return $max;
			
	}	
	private function setCatId($cats=null){
		global $plxAdmin,$plxMotor;
		if (!$cats&&!empty($plxAdmin)){
			$cats=$plxAdmin->aCats;
		}elseif (!$cats&&!empty($plxMotor)){
			$cats=$plxMotor->aCats;
		}else{return 'houla';}
		foreach ($cats as $id => $data) {
			if (mb_strtolower($data['name'])==mb_strtolower($this->title)){
				$this->catId=$id;
				return $id;
			}
		}
		if (empty($cats2[$this->title])){
			$id++;
			$id="$id";
			$id=str_repeat('0', 3-strlen($id)).$id;
		}
		$this->catId=$id;
		return $id;
	}


	########################################
	# today
	########################################
	# Renvoie la date et l'heure du jour
	private function today(){
        $jour=@date("D");
        $njour=@date("j");
        $nmois=@date("n");
        $an=@date("Y");
        $ja="Mon Tue Wen Thu Fri Sat Sun ";
        $jf="Lundi Mardi Mercredi Jeudi Vendredi Samedi Dimanche ";
        $tjours=explode(" ",$jf);
        $mf="Janvier Février Mars Avril Mai Juin Juillet Août Septembre Octobre Novembre Décembre ";
        $tmois=explode(" ",$mf);

        $nj=strpos($ja,$jour)/4;

        $jour=$tjours[$nj];
        $mois=$tmois[$nmois-1];
        $z=$jour." ".$njour." ".$mois." ".$an;
        return $z.' à '.date('H:i:s');
	}


}





/* Pense-bete:
 * Récuperer des parametres du fichier parameters.xml
 *	$this->getParam("<nom du parametre>")
 *	$this-> setParam ("param1", 12345, "numeric")
 *	$this->saveParams()
 *
 *	plxUtils::strCheck($string) : sanitize string
 *
 * 
 * Quelques constantes utiles: 
 * PLX_CORE
 * PLX_ROOT
 * PLX_CHARSET
 * PLX_CONFIG_PATH
 * PLX_PLUGINS
 * PLX_CONFIG_PATH
 * PLX_ADMIN (true si on est dans admin)
 * PLX_CHARSET
 * PLX_VERSION
 * PLX_FEED
 *
 * Appel de HOOK dans un thème
 *	eval($plxShow->callHook("showLinkedURL","param1"))  ou eval($plxShow->callHook("ThemeEndHead",array("param1","param2")))
 *	ou $retour=$plxShow->callHook("ThemeEndHead","param1"));
 */